format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn g_print
extrn gtk_init
extrn gtk_window_new
extrn gtk_signal_connect
extrn gtk_widget_show
extrn gtk_main
extrn exit
extrn gtk_window_set_default_size
extrn gtk_container_set_border_width
extrn gtk_container_add
extrn gtk_table_attach
extrn gtk_table_new
extrn gtk_label_new
extrn gtk_entry_append_text
extrn gtk_entry_set_text
extrn gtk_entry_set_editable
extrn gtk_entry_new

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg       db "closing application...", 10, 10, 0
    szSome          db "Some text...", 0
    szAppend        db "and some appended text", 0
    szEdit          db "Editable text entry widget", 0
    szNonEdit       db "Non-editable text entry widget", 0

section '.bss' writeable

    hWindow         dd ?
    hTable          dd ?
    hLabel1         dd ?
    hLabel2         dd ?
    hEntry1         dd ?
    hEntry2         dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    call gtk_entry_new
    mov [hEntry1], eax
    call gtk_entry_new
    mov [hEntry2], eax

    ccall gtk_entry_set_editable, [hEntry2], FALSE

    ccall gtk_entry_set_text, [hEntry1], szSome
    ccall gtk_entry_append_text, [hEntry1], szAppend
    ccall gtk_entry_set_text, [hEntry2], szSome
    ccall gtk_entry_append_text, [hEntry2], szAppend

    ccall gtk_label_new, szEdit
    mov [hLabel1], eax
    ccall gtk_label_new, szNonEdit
    mov [hLabel2], eax

    ccall gtk_table_new, 2, 2, FALSE
    mov [hTable], eax

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent

    ccall gtk_table_attach, [hTable], [hLabel1], 0, 1, 0, 1, GTK_EXPAND or GTK_SHRINK or GTK_FILL, GTK_EXPAND or GTK_SHRINK or GTK_FILL, 0, 0
    ccall gtk_table_attach, [hTable], [hLabel2], 0, 1, 1, 2, GTK_EXPAND or GTK_SHRINK or GTK_FILL, GTK_EXPAND or GTK_SHRINK or GTK_FILL, 0, 0
    ccall gtk_table_attach, [hTable], [hEntry1], 1, 2, 0, 1, GTK_EXPAND or GTK_SHRINK or GTK_FILL, GTK_EXPAND or GTK_SHRINK or GTK_FILL, 0, 0
    ccall gtk_table_attach, [hTable], [hEntry2], 1, 2, 1, 2, GTK_EXPAND or GTK_SHRINK or GTK_FILL, GTK_EXPAND or GTK_SHRINK or GTK_FILL, 0, 0

    ccall gtk_container_add, [hWindow], [hTable]

    ccall gtk_container_set_border_width, [hWindow], 5

    ccall gtk_window_set_default_size, [hWindow], 500, 100

    ccall gtk_widget_show, [hTable]
    ccall gtk_widget_show, [hEntry1]
    ccall gtk_widget_show, [hEntry2]
    ccall gtk_widget_show, [hLabel1]
    ccall gtk_widget_show, [hLabel2]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
