format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn gtk_window_new
extrn gtk_init
extrn gtk_vbox_new
extrn gtk_text_new
extrn gtk_handle_box_new
extrn gtk_menu_bar_new
extrn gtk_text_set_editable
extrn gtk_signal_connect
extrn gtk_menu_item_new_with_label
extrn gtk_menu_bar_append
extrn gtk_widget_show
extrn gtk_menu_new
extrn gtk_menu_item_set_submenu
extrn gtk_menu_append
extrn gtk_box_pack_start
extrn gtk_container_add
extrn gtk_text_insert
extrn gtk_container_set_border_width
extrn gtk_window_set_default_size
extrn gtk_window_set_title
extrn gtk_main
extrn g_print
extrn exit

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg       db "closing application...", 10, 10, 0
    szActivate      db "activate", 0
    szMenuFile      db "File", 0
    szMenuNew       db "New", 0
    szMenuOpen      db "Open", 0
    szMenuExit      db "Exit", 0
    szMenuEdit      db "Edit", 0
    szMenuUndo      db "Undo", 0
    szMenuCopy      db "Copy", 0
    szMenuCut       db "Cut", 0
    szMenuHelp      db "Help", 0
    szMenuAbout     db "About", 0
    szHandleBox     db "HandleBox", 0
    szText          db "Select Exit from the File menu to close the application."
    szTextLen       = $ - szText

section '.bss' writeable

    hWindow         dd ?
    hMenuFile       dd ?
    hMenuEdit       dd ?
    hMenuHelp       dd ?
    hMenubar        dd ?
    hMenu           dd ?
    hMenuItem       dd ?
    hVbox           dd ?
    hHandlebox      dd ?
    hText           dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    ccall gtk_vbox_new, FALSE, 0
    mov [hVbox], eax

    ccall gtk_text_new, 0, 0
    mov [hText], eax

    call gtk_handle_box_new
    mov [hHandlebox], eax

    call gtk_menu_bar_new
    mov [hMenubar], eax

    ccall gtk_text_set_editable, [hText], TRUE

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent, 0

    ccall gtk_menu_item_new_with_label, szMenuFile
    mov [hMenuFile], eax

    ccall gtk_menu_bar_append, [hMenubar], [hMenuFile]

    ccall gtk_widget_show, [hMenuFile]

    call gtk_menu_new
    mov [hMenu], eax

    ccall gtk_menu_item_set_submenu, [hMenuFile], [hMenu]

    ccall gtk_menu_item_new_with_label, szMenuNew
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_widget_show, [hMenuItem]

    ccall gtk_menu_item_new_with_label, szMenuOpen
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_widget_show, [hMenuItem]

    ccall gtk_menu_item_new_with_label, szMenuExit
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_signal_connect, [hMenuItem], szActivate, DeleteEvent
    ccall gtk_widget_show, [hMenuItem]


    ccall gtk_menu_item_new_with_label, szMenuEdit
    mov [hMenuEdit], eax

    ccall gtk_menu_bar_append, [hMenubar], [hMenuEdit]

    ccall gtk_widget_show, [hMenuEdit]

    call gtk_menu_new
    mov [hMenu], eax

    ccall gtk_menu_item_set_submenu, [hMenuEdit], [hMenu]

    ccall gtk_menu_item_new_with_label, szMenuUndo
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_widget_show, [hMenuItem]

    ccall gtk_menu_item_new_with_label, szMenuCopy
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_widget_show, [hMenuItem]

    ccall gtk_menu_item_new_with_label, szMenuCut
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_widget_show, [hMenuItem]


    ccall gtk_menu_item_new_with_label, szMenuHelp
    mov [hMenuHelp], eax

    ccall gtk_menu_bar_append, [hMenubar], [hMenuHelp]

    ccall gtk_widget_show, [hMenuHelp]

    call gtk_menu_new
    mov [hMenu], eax

    ccall gtk_menu_item_set_submenu, [hMenuHelp], [hMenu]

    ccall gtk_menu_item_new_with_label, szMenuAbout
    mov [hMenuItem], eax
    ccall gtk_menu_append, [hMenu], [hMenuItem]
    ccall gtk_widget_show, [hMenuItem]


    ccall gtk_container_add, [hHandlebox], [hMenubar]

    ccall gtk_box_pack_start, [hVbox], [hHandlebox], FALSE, TRUE, 0

    ccall gtk_container_add, [hVbox], [hText]

    ccall gtk_container_add, [hWindow], [hVbox]

    ccall gtk_text_insert, [hText], 0, 0, 0, szText, szTextLen

    ccall gtk_container_set_border_width, [hWindow], 0

    ccall gtk_window_set_default_size, [hWindow], 640, 200

    ccall gtk_window_set_title, [hWindow], szHandleBox

    ccall gtk_widget_show, [hHandlebox]
    ccall gtk_widget_show, [hVbox]
    ccall gtk_widget_show, [hText]
    ccall gtk_widget_show, [hMenuItem]
    ccall gtk_widget_show, [hMenubar]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
