format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn gtk_window_new
extrn gtk_hpaned_new
extrn gtk_text_new
extrn gtk_signal_connect
extrn gtk_paned_add1
extrn gtk_paned_add2
extrn gtk_container_add
extrn gtk_widget_show
extrn gtk_main
extrn gtk_init
extrn g_print
extrn exit
extrn gtk_text_insert
extrn gtk_container_set_border_width
extrn gtk_window_set_default_size
extrn gtk_window_set_title
extrn gtk_text_set_editable

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg       db "closing application...", 10, 10, 0

    szTextLeft      db "This is the left text pane"
    szTextLeftLen   = $ - szTextLeft
    szTextRight     db "This is the right text pane"
    szTextRightLen  = $ - szTextRight
    szTitle         db "A horizontal splitter", 0

section '.bss' writeable

    hWindow         dd ?
    hHpane          dd ?
    hText1          dd ?
    hText2          dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    call gtk_hpaned_new
    mov [hHpane], eax

    ccall gtk_text_new, 0, 0
    mov [hText1], eax

    ccall gtk_text_new, 0, 0
    mov [hText2], eax

    ccall gtk_text_set_editable, [hText1], TRUE
    ccall gtk_text_set_editable, [hText2], TRUE

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent, 0

    ccall gtk_paned_add1, [hHpane], [hText1]

    ccall gtk_paned_add2, [hHpane], [hText2]

    ccall gtk_container_add, [hWindow], [hHpane]

    ccall gtk_text_insert, [hText1], 0, 0, 0, szTextLeft, szTextLeftLen

    ccall gtk_text_insert, [hText2], 0, 0, 0, szTextRight, szTextRightLen

    ccall gtk_container_set_border_width, [hWindow], 0

    ccall gtk_window_set_default_size, [hWindow], 640, 200

    ccall gtk_window_set_title, [hWindow], szTitle

    ccall gtk_widget_show, [hHpane]
    ccall gtk_widget_show, [hText1]
    ccall gtk_widget_show, [hText2]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
